#This is module file for the perlbot.pl
# add all global functions and definitions here


$BOTMSG_Line=0;  # Send a message
$BOTMSG_Register=1;  # Register a command
$BOTMSG_LineSound=2;  # Send a message with a sound

$BOTCMD_Init=0;
$BOTCMD_Entered=1;
$BOTCMD_Left=2;
$BOTCMD_Kill=3;
$BOTCMD_Line=4;
$BOTCMD_Shutdown=5;
$BOTCMD_Command=6;
$BOTCMD_Arena=7;    # changing arenas, forget everything you know
                                     # Arena name is in "Line" and is "" for pub
$BOTCMD_Tick=8;    # called every 50ms or so
$BOTCMD_ShipChange=9;
$BOTCMD_FreqChange=10;

# *todo* chat, squad, rederror
$LINETYPE_Arena=0;  # does not have user data
$LINETYPE_Macro=1;
$LINETYPE_Pub=2;
$LINETYPE_Team=3;
$LINETYPE_AnyTeam=4;
$LINETYPE_Private=5;
$LINETYPE_CrossZone=7;  # does not have user data

$LINETYPE_SysopMsg=8;  # does not have user data
$LINETYPE_Chat=9;  # does not have user data

$Init    = 0;
$Name = 1;
$Squad = 2;
$LastFreq=7;
$LastShip =7;
$Shiptype =3;
$Freq =4;
$UID =5;
$IsValid =6;
$LineType =7;
$Line = 8;

%ShipTypeH = (
    0 => 'Spectator',
    1 => 'Warbird',
    2 => 'Javelin',
    3 => 'Spider',
    4 => 'Leviathan',
    5 => 'Terrier',
    6 => 'Weasel',
    7 => 'Lancaster',
    8 => 'Shark'
                );

%LineTypeH = (
    0 => 'Arena',   
    1 => 'Macro',
    2 => 'Public', 
    3 => 'Team',
    4 => 'AnyTeam',
    5 => 'Private',
    7 => 'CrossZone', 
    8 => 'SysopMessage',
    9 => 'Chat'
                );
%Event = (
    Init=>0,
    Entered=>1,
    Left=>2,
    Kill=>3,
    Line=>4,
    Shutdown=>5,
    Command=>6,
    Arena=>7,
    Tick=>8,
    ShipChange=>9,
    FreqChange=>10
         );
    

#This function maps INPERL array to hash and returns it.
sub InPerlHash{
    #the size cant lie .. using this we know what data we are getting in @INPERL
    # The size of array is 8 except if the BOT_CMD is BOTCMD_line.
    my $size = @INPERL;
    # @INPERL IS CONTAINS next items and in this order
    # $INPERL[0] = [BOTCMD_x ] where x is any BOTCMD's defined in bot.h
    # $INPERL[1] = [Name    ]   the player name
    # $INPERL[2] = [Squad   ]   the squad name
    # $INPERL[3] = [LastShip]  the lastship the player in [Name] was using
    # $INPERL[4] = [ShipType] the ship the player in [Name] is currently using
    # $INPERL[5] = [Freq]       the frequence the player in [Name] is currently 
    # $INPERL[6] = [UID]        the User ID of the player in [Name]
    # $INPERL[7] = [IsValid]    Is the player currently in arena and valid.

    #Map all this to the hash
    my %hash = (
        Command => $INPERL[0],
        Name    => $INPERL[$Name],                          #or [1]
        Squad   => $INPERL[$Squad],                         #or [2] 
        Ship    =>  $ShipTypeH{$INPERL[$Shiptype]},  #or SHIPTYPES[INPERL[3]] will be the name of the ship
        Freq    => $INPERL[$Freq],                            #or [4]
        UserID  => $INPERL[$UID],                            #or [5]
        IsValid  => $INPERL[$IsValid],                        #or [6] 
               );
    
    # If @INPERL contains 10 elements it must be then BOTCMD_Line which imports some more information
    if ($hash{Command} == $BOTCMD_ShipChange ) {
        $hash{LastShip} = $ShipTypeH{$INPERL[$LastShip]};
    }
    if ($hash{Command} == $BOTCMD_FreqChange) {
        $hash{LastFreq} = $INPERL[$LastFreq];
    }

    if ( $hash{Command} == $BOTCMD_Line)
    {
        $hash{LineType} = $LineTypeH{$INPERL[$LineType]}; # or LINETYPES[INPERL[8]] 
        $hash{Line}        = $INPERL[$Line];                      # or [9]          
    }
    # If even bigger then its BOTCMD_killer,killed msg which imports both players involved plus bty
    if ($hash{Command} == $BOTCMD_Kill)
    {
        $hash{Name2} = $INPERL[7];
        $hash{Squad2} =$INPERL[8];
        $hash{Ship2}    = $ShipTypeH{$INPERL[9]};
        $hash{Freq2}    = $INPERL[10];
        $hash{UserID2}  = $INPERL[11];
        $hash{isValid2}  = $INPERL[12];
        $hash{Bounty}  = $INPERL[13];
    }
    return %hash;
}
sub LogPrint {
    my ($CMD,$message,@data) = @_;
    open (LOGFILE,">>log.txt");
    print LOGFILE ".........................\n";
    print LOGFILE "CMD:[", $CMD, "]: ", $message ,":","@data \t","\n";
    print LOGFILE br();
    close (LOGFILE);
}


sub BugPrint {
    my $msg = shift @_;
    open (LOGFILE,">>log.txt");
    print LOGFILE ".......... $msg .............\n";
    print LOGFILE "INPERL: @INPERL \t","\n";
    my %PlayerData = &InPerlHash(); 
    foreach $keys  (keys %PlayerData) {
        print LOGFILE "$keys : $PlayerData{$keys}\n";
    };
    close (LOGFILE);
}

1;
__END__
